diff --git a/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java b/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
index 3662b577b..ad24ed71f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
+++ b/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
@@ -32,348 +32,353 @@ import net.minecraft.client.render.PanelCrashReport;
 import net.minecraft.core.UnexpectedThrowable;
 
 public class GameWindowGLFW implements GameWindow {
-	public Minecraft mc;
-	
-	public long window;
-
-	private boolean wasResized = false;
-	private boolean isFullscreen = false;
-	private boolean hasFocus = true;
-	
-	private int windowPosX;
-	private int windowPosY;
-	private int windowWidth;
-	private int windowHeight;
-
-	private int widthScreenCoords;
-	private int heightScreenCoords;
-
-	private int widthPixels;
-	private int heightPixels;
-	
-	@Override
-	public void init(Minecraft minecraft, int width, int height) {
-		mc = minecraft;
-		
-		System.out.println("GLFW Init");
-		if(!glfwInit()) {
-			throw new RuntimeException("GLFW Init failed!");
-		}
-		
-		// Set window hints
-		glfwWindowHint(GLFW_RESIZABLE, 1);
-		glfwWindowHint(GLFW_VISIBLE, 0);
-		glfwWindowHint(GLFW_AUTO_ICONIFY, 1);
-		glfwWindowHint(GLFW_DECORATED, 1);
-		
-		// Create window
-		window = glfwCreateWindow(width, height, "Better than Adventure! " + Global.VERSION, 0, 0);
-
-		// Set widths and heights
-		int[] w = new int[1];
-		int[] h = new int[1];
-		glfwGetWindowSize(window, w, h);
-		this.widthScreenCoords = w[0];
-		this.heightScreenCoords = h[0];
-		glfwGetFramebufferSize(window, w, h);
-		this.widthPixels = w[0];
-		this.heightPixels = h[0];
-
-		// Center window
-		MonitorInfo monitor = new MonitorInfo(glfwGetPrimaryMonitor());
-		glfwSetWindowPos(window, (monitor.widthScreenCoords - widthScreenCoords) / 2, (monitor.heightScreenCoords - heightScreenCoords) / 2);
-		
-		// Setup callbacks
-		glfwSetWindowSizeCallback(window, (window, ww, hh) -> {
-			this.widthScreenCoords = Math.max(1, ww);
-			this.heightScreenCoords = Math.max(1, hh);
-			wasResized = true;
-		});
-
-		glfwSetFramebufferSizeCallback(window, (window, ww, hh) -> {
-			this.widthPixels = Math.max(1, ww);
-			this.heightPixels = Math.max(1, hh);
-			wasResized = true;
-		});
-
-		glfwSetWindowFocusCallback(window, (window, focused) -> {
-			this.hasFocus = focused;
-		});
-
-		// Setup Icon
-		iconLabel: {
-			int[] resolutions = new int[]{16, 32, 64, 128, 256};
-			GLFWImage.Buffer gb = GLFWImage.create(resolutions.length);
-			for (int i = 0; i < resolutions.length; i++) {
-				int res = resolutions[i];
-				ByteBuffer icon = getImageBuffer("/icon/" + res + ".png");
-				if (icon == null) {
-					System.err.println("Icon at resolution '" + res + "' is null! Skipping icons!");
-					gb.close();
-					break iconLabel;
-				}
-				GLFWImage iconGI = GLFWImage.create().set(res, res, icon);
-				gb.put(i, iconGI);
-			}
-			glfwSetWindowIcon(window, gb);
-		}
-
-		// Show window
-		glfwShowWindow(window);
-		
-		// OpenGL setup
-		glfwMakeContextCurrent(window);
-		GL.createCapabilities();
-
-		// Input setup
-		Display.setWindow(this);
-
-		
-		Method createKeyboard;
-		Method createMouse;
-		
-		try {
-			createKeyboard = Keyboard.class.getDeclaredMethod("create", InputImplementation.class);
-			createKeyboard.setAccessible(true);
-			
-			createMouse = Mouse.class.getDeclaredMethod("create", InputImplementation.class);
-			createMouse.setAccessible(true);
-			
-			GLFWKeyboardImplementation keyboardImplementation = new GLFWKeyboardImplementation();
-			GLFWMouseImplementation mouseImplementation = new GLFWMouseImplementation();
-			
-			CombinedInputImplementation inputImplementation = new CombinedInputImplementation(keyboardImplementation, mouseImplementation);
-			
-			createKeyboard.invoke(null, inputImplementation);
-			createMouse.invoke(null, inputImplementation);
-		}catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException | NoSuchMethodException e) {
-			// only catch reflection errors
-			throw new RuntimeException(e);
-		}
-		
-		// Set Vsync
-		setVsync(mc.gameSettings.enableVsync.value);
-	}
-
-	@Override
-	public void toggleFullscreen() {
-		mc.gameSettings.fullscreen.value = !mc.gameSettings.fullscreen.value;
-		
-		updateWindowState();
-	}
-
-	@Override
-	public void updateWindowState() {
-		if(!isFullscreen) {
-			int[] x = new int[1];
-			int[] y = new int[1];
-			glfwGetWindowPos(window, x, y);
-			
-			int[] w = new int[1];
-			int[] h = new int[1];
-			glfwGetWindowSize(window, w, h);
-			
-			this.windowPosX = x[0];
-			this.windowPosY = y[0];
-			this.windowWidth = w[0];
-			this.windowHeight = h[0];
-		}
-		
-		boolean fullscreen = mc.gameSettings.fullscreen.value;
-		boolean borderless = mc.gameSettings.borderlessFullscreen.value;
-		
-		glfwHideWindow(window);
-		
-		if(fullscreen && !borderless) {
-			System.out.println("Change to Fullscreen");
-			int x = windowPosX + windowWidth / 2;
-			int y = windowPosY + windowHeight / 2;
-			MonitorInfo monitor = getMonitorAt(x, y);
-			
-			// Enable GLFW Fullscreen
-			glfwSetWindowMonitor(window, monitor.handle, monitor.posX, monitor.posY, monitor.widthScreenCoords, monitor.heightScreenCoords, monitor.refreshRate);
-			isFullscreen = true;
-		}else {
-			// Disable GLFW Fullscreen
-			glfwSetWindowMonitor(window, 0, windowPosX, windowPosY, windowWidth, windowHeight, 0);
-			
-			if(fullscreen && borderless) {
-				System.out.println("Change to Borderless Fullscreen");
-				int x = windowPosX + windowWidth / 2;
-				int y = windowPosY + windowHeight / 2;
-				MonitorInfo monitor = getMonitorAt(x, y);
-				
-				glfwSetWindowAttrib(window, GLFW_DECORATED, 0);
-				glfwSetWindowPos(window, monitor.posX, monitor.posY);
-				glfwSetWindowSize(window, monitor.widthScreenCoords, monitor.heightScreenCoords);
-				isFullscreen = true;
-			}else {
-				System.out.println("Change to Windowed");
-				glfwSetWindowAttrib(window, GLFW_DECORATED, 1);
-				isFullscreen = false;
-			}
-		}
-		
-		glfwShowWindow(window);
-	}
-	
-	public MonitorInfo getMonitorAt(int x, int y) {
-		PointerBuffer monitorPointers = glfwGetMonitors();
-		
-		for(int i = monitorPointers.position(); i < monitorPointers.limit(); i++) {
-			long monitor = monitorPointers.get(i);
-			
-			MonitorInfo info = new MonitorInfo(monitor);
-			if(x >= info.posX && y >= info.posY && x < info.posX + info.widthScreenCoords && y < info.posY + info.heightScreenCoords) {
-				return info;
-			}
-		}
-		
-		return new MonitorInfo(glfwGetPrimaryMonitor());
-	}
-	
-	@Override
-	public void displayCrashReport(UnexpectedThrowable unexpectedThrowable, int cause) {
-		JFrame frame = new JFrame();
-		Panel panel = new PanelCrashReport(mc, unexpectedThrowable, cause);
-
-		panel.setPreferredSize(new java.awt.Dimension(1280, 720));
-
-		frame.add(panel);
-		frame.pack();
-		frame.setLocationRelativeTo(null);
-		frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
-		frame.setVisible(true);
-	}
-
-	@Override
-	public int getFrequency() {
-		GLFWVidMode vidMode = glfwGetVideoMode(window);
-		if (vidMode != null) {
-			return vidMode.refreshRate();
-		} else {
-			int x = windowPosX + windowWidth / 2;
-			int y = windowPosY + windowHeight / 2;
-			MonitorInfo monitor = getMonitorAt(x, y);
-			return monitor.refreshRate;
-		}
-	}
-	
-	@Override
-	public void update() {
-		glfwPollEvents();
-		
-		Keyboard.poll();
-		Mouse.poll();
-		
-		glfwSwapBuffers(window);
-	}
-
-	@Override
-	public boolean shouldClose() {
-		return glfwWindowShouldClose(window);
-	}
-
-	@Override
-	public int getWidthScreenCoords() {
-		return widthScreenCoords;
-	}
-
-	@Override
-	public int getHeightScreenCoords() {
-		return heightScreenCoords;
-	}
-
-	@Override
-	public int getWidthPixels() {
-		return widthPixels;
-	}
-
-	@Override
-	public int getHeightPixels() {
-		return heightPixels;
-	}
-
-	@Override
-	public boolean isFocused() {
-		return hasFocus;
-	}
-
-	@Override
-	public boolean wasResized() {
-		if(wasResized) {
-			wasResized = false;
-			return true;
-		}
-		return false;
-	}
-
-	@Override
-	public void setVsync(boolean vsync) {
-		if(vsync) {
-			glfwSwapInterval(1);	
-		}else {
-			glfwSwapInterval(0);
-		}
-	}
-	
-	public static class MonitorInfo {
-		
-		public final long handle;
-		public final int posX;
-		public final int posY;
-		public final int widthScreenCoords;
-		public final int heightScreenCoords;
-		public final int refreshRate;
-		
-		public MonitorInfo(long monitor) {
-			this.handle = monitor;
-			
-			GLFWVidMode vidmode = glfwGetVideoMode(monitor);
-			
-			int[] x = new int[1];
-			int[] y = new int[1];
-			glfwGetMonitorPos(monitor, x, y);
-			posX = x[0];
-			posY = y[0];
-			
-			widthScreenCoords = vidmode.width();
-			heightScreenCoords = vidmode.height();
-			refreshRate = vidmode.refreshRate();
-		}
-	}
-
-	/**
-	 * Reads the specified image resource and returns the raw data as a ByteBuffer.
-	 *
-	 * @param resource   the resource to read
-	 * @return the resource data
-	 *
+    public Minecraft mc;
+
+    public long window;
+
+    private boolean wasResized = false;
+    private boolean isFullscreen = false;
+    private boolean hasFocus = true;
+
+    private int windowPosX;
+    private int windowPosY;
+    private int windowWidth;
+    private int windowHeight;
+
+    private int widthScreenCoords;
+    private int heightScreenCoords;
+
+    private int widthPixels;
+    private int heightPixels;
+
+    @Override
+    public void init(Minecraft minecraft, int width, int height) {
+        mc = minecraft;
+
+        System.out.println("GLFW Init");
+        if (!glfwInit()) {
+            throw new RuntimeException("GLFW Init failed!");
+        }
+
+        // Set window hints
+        glfwWindowHint(GLFW_RESIZABLE, 1);
+        glfwWindowHint(GLFW_VISIBLE, 0);
+        glfwWindowHint(GLFW_AUTO_ICONIFY, 1);
+        glfwWindowHint(GLFW_DECORATED, 1);
+
+        // Create window
+        window = glfwCreateWindow(width, height, "Better than Adventure! " + Global.VERSION, 0, 0);
+
+        // Set widths and heights
+        int[] w = new int[1];
+        int[] h = new int[1];
+        glfwGetWindowSize(window, w, h);
+        this.widthScreenCoords = w[0];
+        this.heightScreenCoords = h[0];
+        glfwGetFramebufferSize(window, w, h);
+        this.widthPixels = w[0];
+        this.heightPixels = h[0];
+
+        // Center window
+        MonitorInfo monitor = new MonitorInfo(glfwGetPrimaryMonitor());
+        glfwSetWindowPos(window, (monitor.widthScreenCoords - widthScreenCoords) / 2, (monitor.heightScreenCoords - heightScreenCoords) / 2);
+
+        // Setup callbacks
+        glfwSetWindowSizeCallback(window, (window, ww, hh) -> {
+            this.widthScreenCoords = Math.max(1, ww);
+            this.heightScreenCoords = Math.max(1, hh);
+            wasResized = true;
+        });
+
+        glfwSetFramebufferSizeCallback(window, (window, ww, hh) -> {
+            this.widthPixels = Math.max(1, ww);
+            this.heightPixels = Math.max(1, hh);
+            wasResized = true;
+        });
+
+        glfwSetWindowFocusCallback(window, (window, focused) -> {
+            this.hasFocus = focused;
+            if (Mouse.isGrabbed() && !focused) {
+                Mouse.setGrabbed(false);
+            }
+        });
+
+        // Setup Icon
+        iconLabel:
+        {
+            int[] resolutions = new int[]{16, 32, 64, 128, 256};
+            GLFWImage.Buffer gb = GLFWImage.create(resolutions.length);
+            for (int i = 0; i < resolutions.length; i++) {
+                int res = resolutions[i];
+                ByteBuffer icon = getImageBuffer("/icon/" + res + ".png");
+                if (icon == null) {
+                    System.err.println("Icon at resolution '" + res + "' is null! Skipping icons!");
+                    gb.close();
+                    break iconLabel;
+                }
+                GLFWImage iconGI = GLFWImage.create().set(res, res, icon);
+                gb.put(i, iconGI);
+            }
+            glfwSetWindowIcon(window, gb);
+        }
+
+        // Show window
+        glfwShowWindow(window);
+
+        // OpenGL setup
+        glfwMakeContextCurrent(window);
+        GL.createCapabilities();
+
+        // Input setup
+        Display.setWindow(this);
+
+
+        Method createKeyboard;
+        Method createMouse;
+
+        try {
+            createKeyboard = Keyboard.class.getDeclaredMethod("create", InputImplementation.class);
+            createKeyboard.setAccessible(true);
+
+            createMouse = Mouse.class.getDeclaredMethod("create", InputImplementation.class);
+            createMouse.setAccessible(true);
+
+            GLFWKeyboardImplementation keyboardImplementation = new GLFWKeyboardImplementation();
+            GLFWMouseImplementation mouseImplementation = new GLFWMouseImplementation();
+
+            CombinedInputImplementation inputImplementation = new CombinedInputImplementation(keyboardImplementation, mouseImplementation);
+
+            createKeyboard.invoke(null, inputImplementation);
+            createMouse.invoke(null, inputImplementation);
+        } catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException |
+                 NoSuchMethodException e) {
+            // only catch reflection errors
+            throw new RuntimeException(e);
+        }
+
+        // Set Vsync
+        setVsync(mc.gameSettings.enableVsync.value);
+    }
+
+    @Override
+    public void toggleFullscreen() {
+        mc.gameSettings.fullscreen.value = !mc.gameSettings.fullscreen.value;
+
+        updateWindowState();
+    }
+
+    @Override
+    public void updateWindowState() {
+        if (!isFullscreen) {
+            int[] x = new int[1];
+            int[] y = new int[1];
+            glfwGetWindowPos(window, x, y);
+
+            int[] w = new int[1];
+            int[] h = new int[1];
+            glfwGetWindowSize(window, w, h);
+
+            this.windowPosX = x[0];
+            this.windowPosY = y[0];
+            this.windowWidth = w[0];
+            this.windowHeight = h[0];
+        }
+
+        boolean fullscreen = mc.gameSettings.fullscreen.value;
+        boolean borderless = mc.gameSettings.borderlessFullscreen.value;
+
+        glfwHideWindow(window);
+
+        if (fullscreen && !borderless) {
+            System.out.println("Change to Fullscreen");
+            int x = windowPosX + windowWidth / 2;
+            int y = windowPosY + windowHeight / 2;
+            MonitorInfo monitor = getMonitorAt(x, y);
+
+            // Enable GLFW Fullscreen
+            glfwSetWindowMonitor(window, monitor.handle, monitor.posX, monitor.posY, monitor.widthScreenCoords, monitor.heightScreenCoords, monitor.refreshRate);
+            isFullscreen = true;
+        } else {
+            // Disable GLFW Fullscreen
+            glfwSetWindowMonitor(window, 0, windowPosX, windowPosY, windowWidth, windowHeight, 0);
+
+            if (fullscreen && borderless) {
+                System.out.println("Change to Borderless Fullscreen");
+                int x = windowPosX + windowWidth / 2;
+                int y = windowPosY + windowHeight / 2;
+                MonitorInfo monitor = getMonitorAt(x, y);
+
+                glfwSetWindowAttrib(window, GLFW_DECORATED, 0);
+                glfwSetWindowPos(window, monitor.posX, monitor.posY);
+                glfwSetWindowSize(window, monitor.widthScreenCoords, monitor.heightScreenCoords);
+                isFullscreen = true;
+            } else {
+                System.out.println("Change to Windowed");
+                glfwSetWindowAttrib(window, GLFW_DECORATED, 1);
+                isFullscreen = false;
+            }
+        }
+
+        glfwShowWindow(window);
+    }
+
+    public MonitorInfo getMonitorAt(int x, int y) {
+        PointerBuffer monitorPointers = glfwGetMonitors();
+
+        for (int i = monitorPointers.position(); i < monitorPointers.limit(); i++) {
+            long monitor = monitorPointers.get(i);
+
+            MonitorInfo info = new MonitorInfo(monitor);
+            if (x >= info.posX && y >= info.posY && x < info.posX + info.widthScreenCoords && y < info.posY + info.heightScreenCoords) {
+                return info;
+            }
+        }
+
+        return new MonitorInfo(glfwGetPrimaryMonitor());
+    }
+
+    @Override
+    public void displayCrashReport(UnexpectedThrowable unexpectedThrowable, int cause) {
+        JFrame frame = new JFrame();
+        Panel panel = new PanelCrashReport(mc, unexpectedThrowable, cause);
+
+        panel.setPreferredSize(new java.awt.Dimension(1280, 720));
+
+        frame.add(panel);
+        frame.pack();
+        frame.setLocationRelativeTo(null);
+        frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
+        frame.setVisible(true);
+    }
+
+    @Override
+    public int getFrequency() {
+        GLFWVidMode vidMode = glfwGetVideoMode(window);
+        if (vidMode != null) {
+            return vidMode.refreshRate();
+        } else {
+            int x = windowPosX + windowWidth / 2;
+            int y = windowPosY + windowHeight / 2;
+            MonitorInfo monitor = getMonitorAt(x, y);
+            return monitor.refreshRate;
+        }
+    }
+
+    @Override
+    public void update() {
+        glfwPollEvents();
+
+        if (isFocused()) {
+            Keyboard.poll();
+        }
+        Mouse.poll();
+
+        glfwSwapBuffers(window);
+    }
+
+    @Override
+    public boolean shouldClose() {
+        return glfwWindowShouldClose(window);
+    }
+
+    @Override
+    public int getWidthScreenCoords() {
+        return widthScreenCoords;
+    }
+
+    @Override
+    public int getHeightScreenCoords() {
+        return heightScreenCoords;
+    }
+
+    @Override
+    public int getWidthPixels() {
+        return widthPixels;
+    }
+
+    @Override
+    public int getHeightPixels() {
+        return heightPixels;
+    }
+
+    @Override
+    public boolean isFocused() {
+        return hasFocus;
+    }
+
+    @Override
+    public boolean wasResized() {
+        if (wasResized) {
+            wasResized = false;
+            return true;
+        }
+        return false;
+    }
+
+    @Override
+    public void setVsync(boolean vsync) {
+        if (vsync) {
+            glfwSwapInterval(1);
+        } else {
+            glfwSwapInterval(0);
+        }
+    }
+
+    public static class MonitorInfo {
+
+        public final long handle;
+        public final int posX;
+        public final int posY;
+        public final int widthScreenCoords;
+        public final int heightScreenCoords;
+        public final int refreshRate;
+
+        public MonitorInfo(long monitor) {
+            this.handle = monitor;
+
+            GLFWVidMode vidmode = glfwGetVideoMode(monitor);
+
+            int[] x = new int[1];
+            int[] y = new int[1];
+            glfwGetMonitorPos(monitor, x, y);
+            posX = x[0];
+            posY = y[0];
+
+            widthScreenCoords = vidmode.width();
+            heightScreenCoords = vidmode.height();
+            refreshRate = vidmode.refreshRate();
+        }
+    }
+
+    /**
+     * Reads the specified image resource and returns the raw data as a ByteBuffer.
+     *
+     * @param resource the resource to read
+     * @return the resource data
      */
-	public static ByteBuffer getImageBuffer(String resource) {
-		try {
-			BufferedImage image = ImageIO.read(GameWindowGLFW.class.getResourceAsStream(resource));
-			ByteBuffer buf = createByteBuffer(image.getWidth() * image.getHeight() * 4);
-			// Manually filling out the damn buffer since I can't find any utility that actually does it properly
-			// I don't understand why icon loading for LWJGL3 is such a pain in the ass too
-			int index = 0;
-			for (int y = 0; y < image.getHeight(); y++) {
-				for (int x = 0; x < image.getWidth(); x++) {
-					int color = image.getRGB(x, y);
-					buf.put(index + 0, (byte) Color.redFromInt(color)); // Red
-					buf.put(index + 1, (byte) Color.greenFromInt(color)); // Green
-					buf.put(index + 2, (byte) Color.blueFromInt(color)); // Blue
-					buf.put(index + 3, (byte) Color.alphaFromInt(color)); // Alpha
-					index += 4;
-				}
-			}
-			buf.flip();
-			return buf;
-		}
-		catch (Exception e){
-			System.out.println("Couldn't open icon image...");
-			e.printStackTrace();
-			return null;
-		}
-	}
+    public static ByteBuffer getImageBuffer(String resource) {
+        try {
+            BufferedImage image = ImageIO.read(GameWindowGLFW.class.getResourceAsStream(resource));
+            ByteBuffer buf = createByteBuffer(image.getWidth() * image.getHeight() * 4);
+            // Manually filling out the damn buffer since I can't find any utility that actually does it properly
+            // I don't understand why icon loading for LWJGL3 is such a pain in the ass too
+            int index = 0;
+            for (int y = 0; y < image.getHeight(); y++) {
+                for (int x = 0; x < image.getWidth(); x++) {
+                    int color = image.getRGB(x, y);
+                    buf.put(index + 0, (byte) Color.redFromInt(color)); // Red
+                    buf.put(index + 1, (byte) Color.greenFromInt(color)); // Green
+                    buf.put(index + 2, (byte) Color.blueFromInt(color)); // Blue
+                    buf.put(index + 3, (byte) Color.alphaFromInt(color)); // Alpha
+                    index += 4;
+                }
+            }
+            buf.flip();
+            return buf;
+        } catch (Exception e) {
+            System.out.println("Couldn't open icon image...");
+            e.printStackTrace();
+            return null;
+        }
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
index 74353919e..03c24ad2e 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClientMP.java
@@ -39,6 +39,9 @@ public class WorldClientMP extends WorldClient {
     @Override
 	public void tick()
     {
+        if (getGameRuleValue(GameRules.DO_DAY_CYCLE)) {
+            levelData.setWorldTime(levelData.getWorldTime() + 1L);
+        }
         for(int k = 0; k < 10 && !reEntries.isEmpty(); k++)
         {
             Entity entity = reEntries.iterator().next();
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
index c7e699f21..fee3177ac 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
@@ -240,7 +240,7 @@ public class BlockLogicFarmland extends BlockLogic implements IBonemealable
 	@Override
 	public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
 		int data = world.getBlockMetadata(blockX, blockY, blockZ);
-		if (!isFertilized(data)) {
+		if (!isFertilized(data) && itemstack.consumeItem(player)) {
 			world.setBlockMetadataWithNotify(blockX, blockY, blockZ, setFertilized(data, true));
 			return true;
 		}
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java
index f3ae7a779..3ab47988e 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java
@@ -60,7 +60,7 @@ public class MobSkeleton extends MobMonster
         {
             float f = getBrightness(1.0F);
             if(f > 0.5F && world.canBlockSeeTheSky(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z)) && random.nextFloat() * 30F < (f - 0.4F) * 2.0F
-             && (world.getCurrentWeather() != Weathers.OVERWORLD_FOG || world.weatherManager.getWeatherPower() < 0.75F))
+                && !world.getCurrentWeather().isDamp && (world.getCurrentWeather() != Weathers.OVERWORLD_FOG || world.weatherManager.getWeatherPower() < 0.75F))
             {
                 remainingFireTicks = 300;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java
index b15a864e2..6d34b806e 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java
@@ -5,6 +5,7 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
 
 public class MobZombie extends MobMonster
@@ -25,9 +26,10 @@ public class MobZombie extends MobMonster
     {
         if(world.isDaytime())
         {
+            Weather currentWeather = world.getCurrentWeather();
             float f = getBrightness(1.0F);
             if(f > 0.5F && world.canBlockSeeTheSky(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z)) && random.nextFloat() * 30F < (f - 0.4F) * 2.0F
-                    && (world.getCurrentWeather() != Weathers.OVERWORLD_FOG || world.weatherManager.getWeatherPower() < 0.75F))
+                && !world.getCurrentWeather().isDamp && (world.getCurrentWeather() != Weathers.OVERWORLD_FOG || world.weatherManager.getWeatherPower() < 0.75F))
             {
                 remainingFireTicks = 300;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
index f9921b073..081a74f21 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
@@ -47,10 +47,9 @@ public class ItemBlock<T extends BlockLogic> extends Item
 		if(y < 0 || y >= world.getHeightBlocks()) {
 			return false;
 		}
-		if(world.canBlockBePlacedAt(block.id(), x, y, z, false, side)) {
+		if(world.canBlockBePlacedAt(block.id(), x, y, z, false, side) && stack.consumeItem(player)) {
 			int meta = getPlacedBlockMetadata(player, stack, world, x, y, z, side, xPlaced, yPlaced);
 			if(world.setBlockAndMetadataWithNotify(x, y, z, block.id(), meta)) {
-				stack.consumeItem(player);
 				if (player == null) {
                     block.onBlockPlacedOnSide(world, x, y, z, side, xPlaced, yPlaced);
                 } else {
@@ -58,6 +57,8 @@ public class ItemBlock<T extends BlockLogic> extends Item
                 }
 				world.playBlockSoundEffect(player, x + 0.5F, y + 0.5F, z + 0.5F, block, EnumBlockSoundEffectType.PLACE);
 				return true;
+			} else if (player == null || player.getGamemode().consumeBlocks()) {
+                stack.stackSize += 1;
 			}
 		}
 		return false;
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java b/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java
index 47ce15638..97c6f6e9c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java
@@ -17,6 +17,7 @@ public abstract class Weather
 	public int precipitationType = 0;
 	public boolean spawnRainParticles = false;
 	public boolean doMobsSpawnInDaylight = false;
+	public boolean isDamp = false;
 	public float fogDistance = 1.0f;
 	
 	public Weather(int id)
@@ -74,6 +75,11 @@ public abstract class Weather
 		doMobsSpawnInDaylight = true;
 		return this;
 	}
+
+	public Weather setDamp() {
+		isDamp = true;
+		return this;
+	}
 	
 	public String getTranslatedName()
 	{
